package pl.net.linux.krzak.kchat.applet;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import pl.net.linux.krzak.kchat.util.kChatTextArea;
import pl.net.linux.krzak.kchat.util.kButton;
import pl.net.linux.krzak.kchat.util.ClickListener;
import pl.net.linux.krzak.kchat.util.MessagesClass;

public class kChatModerator extends Frame implements WindowListener, ClickListener, ActionListener {
    public kChatTextArea textarea = new kChatTextArea(300,5);
    private kChatApplet applet = null;
    private Scrollbar sbar = new Scrollbar(Scrollbar.VERTICAL,0,0,0,0);

    /** 
    Create Moderator window 
    @param a     - applet
    */
    public kChatModerator(kChatApplet a) { this("",a); }

    /** 
    Create Moderator window 
    @param title - window title
    @param a     - applet
    */
    public kChatModerator(String title, kChatApplet a) {
	/* set this frame */
	applet = a;
	setTitle(title);
	setResizable(true);
	addWindowListener(this);
	setLayout(new BorderLayout());
	
	textarea.setFont(new Font("fixed", Font.BOLD, 12));
	textarea.setBackground(Color.white);
	textarea.addClickListener(this);
	textarea.addScroll(sbar);
	textarea.autoScroll(false);
	
	add(textarea, BorderLayout.CENTER);

	kButton bCLOSE = new kButton("CLOSE");
	bCLOSE.addActionListener(this);
	add(bCLOSE, BorderLayout.SOUTH);
	add(sbar,BorderLayout.EAST);

	setSize(400,400);
	setVisible(true);
    }
    
    /**
	Handle selected item in textarea
	@see ClickListener
    */
    public void selectedItem(MessagesClass tx, int state) { 
	if (tx==null) return;
	if (state == kChatTextArea.ACCEPT) applet.net.send("*MSG|" + applet.login + "|CHAN|~" + tx.text + "|" + tx.colortxt + "|");
	textarea.removeMessage(tx);
    }

    /**
	Close Moderator windows and set user as a regular user	
    */
    public void stopModerator() { 
	applet.net.send("*NOMODERATOR");
	applet.bPrivate.setLabel(applet.TXT[6]);
	applet.bPrivate.setActionCommand("PRIVATE");
	applet.bModerator.setLabel(applet.TXT[7]);
	applet.bModerator.setActionCommand("MODERATOR");
	dispose(); 
	applet.moder = null;
    }
    
    public void actionPerformed(ActionEvent e) { stopModerator(); }

    public void windowClosing(WindowEvent e) {
 stopModerator();
 }
    public void windowClosed(WindowEvent e) { }
    public void windowOpened(WindowEvent e) { }
    public void windowIconified(WindowEvent e) { }
    public void windowDeiconified(WindowEvent e) { }
    public void windowActivated(WindowEvent e) {
 }
    public void windowDeactivated(WindowEvent e) {
 }
    
        
}
